﻿using System;
using System.Data;
using System.Configuration;
using System.Linq;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Xml.Linq;
using System.Net.Sockets;
using System.IO;
using System.Net;
using System.Message; 

/// <summary>
/// Summary description for AussieSMS
/// </summary>
public class AussieSMS
{
	public AussieSMS()
	{
		//
		// TODO: Add constructor logic here
		//
	}

    public String mobileID = "";
    public String password = "";
    public String to = "";
    public String from = "";
    public String text = "";
    public String msg_type = "";
    public String model = "";

    public String SetmobileID(String newmobileID)
    {
        this.mobileID = newmobileID;
        return mobileID;
    }

    public String SetPassword(String newpassword)
    {
        this.password = newpassword;
        return password;
    }

    public String SetNumber(String newnumber)
    {
        this.to = newnumber;
        return to;
    }

    public String SetFrom(String newownnum)
    {
        this.from = newownnum;
        return from;
    }

    public String SetType(String newmsg_type)
    {
        this.msg_type = newmsg_type;
        return msg_type;
    }

    public String SetMessage(String newtext)
    {
        this.text = newtext;
        return text;
    }

    private String urlencode(String str)
    {
        return HttpUtility.UrlEncode(str);
    }

    public String Send()
    {
        String Body = "/?sendsms";
        Body += "to=" + this.to;
        Body += "&mobileID=" + urlencode(this.mobileID);
        Body += "&password=" + urlencode(this.password);
        Body += "&text=" + urlencode(this.text); 

        if ((this.from) != "")
        {
            Body += "&from=" + urlencode(this.from);
        }

        if ((this.msg_type) != "")
        {
            Body += "&msg_type=" + urlencode(this.msg_type);
        }

        int ContentLength = Body.Length;

        String Host = "api.aussiesms.com.au";

        String Header = "POST /cgi-bin/SMSsend HTTP/1.0\n" + "Host: " + Host + "\n" + "Content-Type: application/x-www-form-urlencoded\n" + "Content-Length: " + ContentLength + "\n\n" + Body + "\n";

        Socket mysocket = null;
        TcpClient tcpClient;
        StreamWriter streamWriter = null;
        StreamReader streamReader = null;
        NetworkStream networkStream = null;

        String line = "";
        try
        {
            tcpClient = new TcpClient();
            tcpClient.Connect(Host, 80);
            
            mysocket = new Socket(AddressFamily.InterNetwork, SocketType.Stream, ProtocolType.Tcp);
            mysocket.Connect(Host, 80);
            
            networkStream = tcpClient.GetStream();

            streamReader = new StreamReader(networkStream);
            streamWriter = new StreamWriter(networkStream);
            streamWriter.WriteLine(Header);
            streamWriter.Flush();

            line = streamReader.ReadToEnd();

        }
        catch (Exception ex)
        {
            throw new Exception(ex.Message);
        }

        return Header + " " + line;
    }


    public String GetmobileID()
    {
        return this.mobileID;
    }

    public String GetPass()
    {
        return this.password;
    }

    public String GetNumber()
    {
        return this.to;
    }

    public String GetMessage()
    {
        return this.text;
    }

    public String GetOwnNum()
    {
        return this.from;
    }

    public String GetType()
    {
        return this.msg_type;
    }

    public String GetModel()
    {
        return this.model;
    }

    public static byte[] ReadFully(Stream stream)
    {
        byte[] buffer = new byte[32768];
        using (MemoryStream ms = new MemoryStream())
        {
            while (true)
            {
                int read = stream.Read(buffer, 0, buffer.Length);
                if (read <= 0)
                    return ms.ToArray();
                ms.Write(buffer, 0, read);
            }
        }
    }

    public string getImage(string url)
    {
        try

        {
            WebRequest request = WebRequest.Create(url);

            byte[] file = new byte[1024 * 1024];
            Stream stream = request.GetResponse().GetResponseStream();

            file = ReadFully(stream);

            return Convert.ToBase64String(file, Base64FormattingOptions.InsertLineBreaks);
        }

        catch (Exception ex)
        {
            return ex.Message;
        }
    }
}
